import * as react from 'react';
import { EditorStateConfig, EditorState, Extension } from '@codemirror/state';
import { ViewUpdate, EditorView } from '@codemirror/view';

declare type CodeMirrorProps = {
    value?: EditorStateConfig['doc'];
    selection?: EditorStateConfig['selection'];
    onUpdate?: (update: ViewUpdate) => void;
    onEditorViewChange?: (editorView: EditorView) => void;
    onEditorStateChange?: (editorState: EditorState) => void;
    extensions?: Extension[];
    elementProps?: React.ComponentProps<'div'>;
};
declare const CodeMirror: react.ForwardRefExoticComponent<CodeMirrorProps & react.RefAttributes<HTMLDivElement>>;

export { CodeMirrorProps, CodeMirror as default };
